import os
from leapp.libraries.common.config import version
from leapp.libraries.common.rpms import has_package
from leapp.models import InstalledOpenCloudSignedRPM
from leapp.exceptions import StopActorExecutionError
from leapp.libraries.stdlib import CalledProcessError, run, api
from leapp.libraries.common.config import architecture


def fix_shim_for_oc9():
    target_version = version.get_target_version()
    if has_package(InstalledOpenCloudSignedRPM,'shim-aa64'):
        run(['dnf','remove','--noautoremove','shim-aa64','-y'])
        run(['dnf','--disablerepo=*',"--releasever={}".format(target_version),'--enablerepo=baseos-rpms,appstream-rpms','install','shim','-y'])
    else:
        run(['dnf','--disablerepo=*',"--releasever={}".format(target_version),'--enablerepo=baseos-rpms,appstream-rpms','install','shim','-y'])
    # if has_package(InstalledOpenCloudSignedRPM,'fwupdate-libs'):

def remove_conflict_packages():
    target_major_version = version.get_target_major_version()
    source_major_version = version.get_source_major_version()
    UnsupportedPackages=[
            'sssd-libwbclient-devel',
            'libwbclient-devel',
            'intel-qat20',
            'intel-qat20-debuginfo',
            'intel-qat20-debugsource',
            'kmod-intel-qat20',
            'kmod-intel-qat20-debuginfo',
            'kmod-intel-qat20-debugsource',
            'fdo-admin-cli',
            'fdo-client',
            'fdo-init',
            'fdo-manufacturing-server',
            'fdo-owner-cli',
            'fdo-owner-onboarding-server',
            'fdo-rendezvous-server',
            'sgx-aesm-service',
            'sgx-dcap-pccs',
            'sgx-ra-service',
            'tdx-qgs',
            'rust-doc'
        ]
    if source_major_version == '8' and target_major_version =='9':
        for package in UnsupportedPackages:
            if has_package(InstalledOpenCloudSignedRPM,package):
                run(['dnf','remove','-y',package])

def process():
    remove_conflict_packages()
    api.current_logger().info('in prepare_file')
    if os.path.exists("/sys/firmware/efi") and architecture.matches_architecture(architecture.ARCH_ARM64):
        fix_shim_for_oc9()